#
# spec file for package kdump (Version 0.3.0)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison brp-check-internal bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db diffutils e2fsprogs file filesystem fillup findutils flex gawk gcc gdbm gdbm-devel gettext gettext-devel glibc glibc-32bit glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libelf libgcc libgssapi libmudflap libnscd libstdc++ libtool libxcrypt libzio m4 make man mkinitrd mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch perl permissions popt post-build-checks procinfo procps psmisc pwdutils rcs readline reiserfs rpm sed strace sysvinit tar tcpd texinfo timezone udev unzip util-linux vim xfsprogs zlib zlib-devel


Name:           kdump
License:        GPL v2 or later
BuildRequires:  libelf zlib-devel
Version:        0.3.0
Release:        8.14
Requires:       curl openssh kexec-tools
Recommends:     makedumpfile
Summary:        Script for kdump
Group:          System/Kernel
Requires(post): mkinitrd
BuildRequires:  mkinitrd
PreReq:         %insserv_prereq %fillup_prereq
Url:            http://www.suse.de/~bwalle/kdump-helpers/
Source:         %{name}-%{version}.tar.bz2
Patch0:         %{name}-add-elf_getshstrndx
Patch1:         %{name}-fix-disk-space-detection
Patch2:         %{name}-fix-350289
Patch3:         %{name}-fix-ssh-auth
Patch4:         %{name}-network-runlevel3-dependency
Patch5:         %{name}-clarify-README
Patch6:         %{name}-print-stderr
Patch7:         %{name}-reload-memory-hotplug
Patch8:         %{name}-pae.diff
Patch9:         %{name}-fix-kernel-detection
Patch10:        %{name}-filter-mem.diff
Patch11:        %{name}-use-uname-i
Patch12:        %{name}-fix-get_arch.diff
Patch13:        %{name}-get-kernel-version-cmdline.diff
Patch14:        %{name}-remove-empty-dumpdir.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
kdump is a package that includes several scripts for kdump, including
the init script /etc/init.d/kdump and the configuration file for kdump.



Authors:
--------
    Bernhard Walle <bwalle@suse.de>

%debug_package
%prep
%setup
%patch0 -p1
%patch1 -p1
%patch2 -p0
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1

%build
make CFLAGS="$RPM_OPT_FLAGS"

%install
make DESTDIR=$RPM_BUILD_ROOT install
# symlink for init script
mkdir -p $RPM_BUILD_ROOT/sbin
ln -s /etc/init.d/kdump $RPM_BUILD_ROOT/sbin/rckdump
##
# fix sysconfig.kdump for various architectures
##
%ifarch %ix86 x86_64
# add --args-linux kexec command line option as default
sed -i 's@^\(KEXEC_OPTIONS="\)\(.*"[[:blank:]]*$\)@\1--args-linux \2@'\
        $RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.kdump
%endif
%ifarch %ix86 x86_64 ia64
# empty KDUMP_KERNELVER since we have no special kdump kernel on that archs
sed -i -e 's@^\(KDUMP_KERNELVER=\).*$@\1""@' \
   -e 's@^\(KDUMP_COMMANDLINE_APPEND="\)\(.*"[[:blank:]]*$\)@\1maxcpus=1 \2@' \
   $RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.kdump
%endif
%ifarch ia64
# add --noio since kexec is broken without --noio on most machines
sed -i -e 's@^\(KEXEC_OPTIONS="\)\(.*"[[:blank:]]*$\)@\1--noio \2@' \
   $RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.kdump
%endif

%post
if [ ! -e /.buildenv ] ; then
  %{fillup_and_insserv -n kdump kdump}
fi
%ifarch %ix86
if grep -q 'KDUMP_KERNELVER="kdump"' /etc/sysconfig/kdump ; then
    sed -i -e 's@KDUMP_KERNELVER="kdump"@KDUMP_KERNELVER=""@g' \
        /etc/sysconfig/kdump
fi
%endif

%preun
if [ ! -e /.buildenv ] ; then
  echo "Stopping kexec ..."
  %stop_on_removal kdump
  true
fi

%postun
if [ ! -e /.buildenv ] ; then
  %restart_on_update kdump
  %insserv_cleanup
fi

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc ChangeLog COPYING README
%{_bindir}/read-debuglink
%{_bindir}/gdb-kdump
%{_sbindir}/kdump-helper
%{_sbindir}/kdump-identify_kernel
%{_sbindir}/kdump-url_parser
%{_sbindir}/kdump-copy_kernel
%{_sbindir}/kdump-copy_progress
%{_sbindir}/kdump-save_dump
%{_sbindir}/kdump-cleanup_dumps
%{_sbindir}/kdump-cat_progress
%{_sbindir}/kdump-led_blink
/sbin/rckdump
%{_mandir}/man1/*
%{_mandir}/man8/*
%{_datadir}/gdbinit.kdump
%dir %{_datadir}/kdump
%{_datadir}/kdump/kdump-shared_functions
/etc/init.d/kdump
/var/adm/fillup-templates/sysconfig.kdump
%{_sysconfdir}/udev/rules.d/70-kdump.rules

%changelog
* Tue Nov 25 2008 - bwalle@suse.de
- Don't set kernel.unknown_nmi_panic sysctl (bnc #388736), revert
  bnc #388736.
* Thu Jul 31 2008 - bwalle@suse.de
- delete empty directories if the dump failed (bnc#413202)
* Wed Jul 30 2008 - bwalle@suse.de
- use kernelver command line parameter to get the version of the
  kernel in the kdump environment more failsafe than
  get_kernel_version /proc/vmcore (bnc#413212)
* Mon Jul 28 2008 - bwalle@suse.de
- Fix kdump-identify_kernel on IA64 (always relocatable).
  The problem was hidden previously because of bnc#394216.
* Fri Jul 25 2008 - bwalle@suse.de
- don't abort after the $(uname -m) output, also use $(uname -i)
  to find makedumpfile.config (bnc#396136)
* Mon Jun 16 2008 - bwalle@suse.de
- replace KDUMP_KERNELVER="kdump" with KDUMP_KERNELVER="" in
  /etc/sysconfig/kdump to use the kdumppae kernel (bnc#396367)
* Fri Jun 13 2008 - bwalle@suse.de
- filter "mem" kernel parameter before loading the kdump kernel
  (bnc#393324)
* Wed Jun 11 2008 - bwalle@suse.de
- fix load of kdump kernel when KDUMP_KERNELVER="kdump" on ppc64
  (bnc#394216)
* Wed Jun 11 2008 - bwalle@suse.de
- implement support for kernel-kdumppae for i386 systems with more
  than 4 GB physical memory (bnc#396367)
* Wed Jun 11 2008 - bwalle@suse.de
- set KDUMP_KERNELVER="" on i386 instead of KDUMP_KERNELVER="kdump"
  (with "kdump", the kdump kernel cannot be loaded without manually
  editing the configuration file (bnc#396221)
- try also $(uname -i) to find the makedumpfile.config in
  /usr/src/linux-${version}-obj/${arch}/${flavour} (bnc#396136)
* Mon May 19 2008 - bwalle@suse.de
- implement "try-restart" command and use that implementation also
  for "condrestart"
- add udev rules to reload kdump configuration on memory or CPU
  hotplug (bnc#389658)
* Mon May 19 2008 - bwalle@suse.de
- panic on unknown NMI (bnc#388736)
- print stderr of kexec invocation (bnc#374185)
* Fri Apr 18 2008 - bwalle@suse.de
- clarified README that memory sizes are only recommended values
  (bnc#380577)
* Wed Feb 20 2008 - bwalle@suse.de
- add missing kexec-tools requirement
- require "$network" in init script so than when runlevel 3 is set
  in /etc/sysconfig/kdump, network is available to the kdump
  scripts (bnc#293171)
* Fri Jan 25 2008 - bwalle@suse.de
- use "-o NumberOfPasswordPrompts=0 -o CheckHostIP=no -o
  StrictHostKeyChecking=no" when calling ssh because the user may
  not be able to confirm the questions (#355973)
* Tue Jan 08 2008 - bwalle@suse.de
- log the result of kexec call to avoid the impression that loading
  kdump kernel succeeded even if kexec terminated non-zero (350289)
- don't set kernel.panic_on_oops to 1 if kexec failed (350289)
* Wed Dec 12 2007 - bwalle@suse.de
- Check the disk space afterwards if makedumpfile is used since
  it's not possible to know the dump image size in advance (347807)
* Mon Nov 12 2007 - tiwai@suse.de
- fix PreReq for insserv and fillup
* Thu Oct 11 2007 - bwalle@suse.de
- new package for SP2, needed to implement saving dumps over
  network (FATE #302174), support to filter kdump images
  (FATE #302175) and dump support for saving no old dumps
  (FATE #302257)
- added syslog message when saving the dump (#331118)
